.686
.model flat,stdcall
option casemap:none
assume fs:nothing
include RADebugeeGUI.inc

.code

WndProc proc stdcall hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov eax,uMsg
	.if eax == WM_CLOSE
		invoke DestroyWindow,hWnd
	.elseif eax == WM_DESTROY
		invoke PostQuitMessage,0
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret
WndProc endp

WinMain proc stdcall uses esi edi ebx hInstance:HINSTANCE,hPrevInstance:HINSTANCE,lpszCmdline:LPSTR,cmdshow:UINT
	LOCAL wc:WNDCLASSEX,msg:MSG
	xor esi,esi
	mov ebx,hInstance
	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,offset WndProc
	mov wc.cbClsExtra,esi
	mov wc.cbWndExtra,DLGWINDOWEXTRA
	mov wc.hInstance,ebx
	mov wc.hbrBackground,COLOR_BTNFACE+1
	mov wc.lpszMenuName,IDM_MENU
	mov wc.lpszClassName,offset szAppClass
	invoke LoadIcon,0,IDI_APPLICATION;,IDR_ICON1
	mov wc.hIcon,eax
	mov wc.hIconSm,eax
	invoke LoadCursor,esi,IDC_ARROW
	mov wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,ebx,IDD_DIALOG,esi,addr WndProc,esi
	mov ebx,eax
	invoke ShowWindow,ebx,SW_SHOWNORMAL
	invoke UpdateWindow,ebx
	lea edi,msg
	jmp @F	
	.repeat
		invoke IsDialogMessage,ebx,edi
		test eax,eax
		jnz @F
		invoke TranslateMessage,edi
		invoke DispatchMessage,edi
@@:		invoke GetMessage,edi,esi,esi,esi
		test eax,eax
	.until zero?
	mov eax,msg.wParam
	ret
WinMain endp

WinMainCRTStartup proc c
	invoke GetModuleHandle,0
	invoke WinMain,eax,0,0,0
	invoke ExitProcess,eax
	invoke InitCommonControls
WinMainCRTStartup endp
	
end WinMainCRTStartup
