;--- include file created by h2incx v0.99.14, copyright 2005 japheth
;--- source file: DbgHelp.h, last modified: 7/26/2004 15:34

;*++ BUILD Version: 0001     Increment this if a change has global effects
;Copyright (c) Microsoft Corporation. All rights reserved.
;Module Name:
;dbghelp.h
;Abstract:
;This module defines the prototypes and constants required for the image
;help routines.
;Contains debugging support routines that are redistributable.
;Revision History:
;--*

IMAGE_SEPARATION	EQU	( 64 * 1024 )

LOADED_IMAGE	struct 4
	ModuleName	PSTR	?
	hFile	HANDLE	?
	MappedAddress	PUCHAR	?
	FileHeader	PIMAGE_NT_HEADERS32	?
	LastRvaSection	PIMAGE_SECTION_HEADER	?
	NumberOfSections	DWORD	?
	Sections	PIMAGE_SECTION_HEADER	?
	Characteristics	DWORD	?
	fSystemImage	BOOLEAN	?
	fDOSImage	BOOLEAN	?
	Links	LIST_ENTRY	<>
	SizeOfImage	DWORD	?
LOADED_IMAGE	ends
PLOADED_IMAGE typedef ptr LOADED_IMAGE

proto_FindDebugInfoFile typedef proto stdcall :PSTR, :PSTR, :PSTR
externdef stdcall _imp__FindDebugInfoFile@12: ptr proto_FindDebugInfoFile
FindDebugInfoFile equ <_imp__FindDebugInfoFile@12>
proto_PFIND_DEBUG_FILE_CALLBACK typedef proto stdcall :HANDLE,:PSTR,:PVOID
PFIND_DEBUG_FILE_CALLBACK typedef ptr proto_PFIND_DEBUG_FILE_CALLBACK
proto_FindDebugInfoFileEx typedef proto stdcall :PSTR, :PSTR, :PSTR, :PFIND_DEBUG_FILE_CALLBACK, :PVOID
externdef stdcall _imp__FindDebugInfoFileEx@20: ptr proto_FindDebugInfoFileEx
FindDebugInfoFileEx equ <_imp__FindDebugInfoFileEx@20>
proto_PFINDFILEINPATHCALLBACK typedef proto stdcall :PSTR,:PVOID
PFINDFILEINPATHCALLBACK typedef ptr proto_PFINDFILEINPATHCALLBACK
proto_SymFindFileInPath typedef proto stdcall :HANDLE, :LPSTR, :LPSTR, :PVOID, :DWORD, :DWORD, :DWORD, :LPSTR, :PFINDFILEINPATHCALLBACK, :PVOID
externdef stdcall _imp__SymFindFileInPath@40: ptr proto_SymFindFileInPath
SymFindFileInPath equ <_imp__SymFindFileInPath@40>
proto_FindExecutableImage typedef proto stdcall :PSTR, :PSTR, :PSTR
externdef stdcall _imp__FindExecutableImage@12: ptr proto_FindExecutableImage
FindExecutableImage equ <_imp__FindExecutableImage@12>
proto_PFIND_EXE_FILE_CALLBACK typedef proto stdcall :HANDLE,:PSTR,:PVOID
PFIND_EXE_FILE_CALLBACK typedef ptr proto_PFIND_EXE_FILE_CALLBACK
proto_FindExecutableImageEx typedef proto stdcall :PSTR, :PSTR, :PSTR, :PFIND_EXE_FILE_CALLBACK, :PVOID
externdef stdcall _imp__FindExecutableImageEx@20: ptr proto_FindExecutableImageEx
FindExecutableImageEx equ <_imp__FindExecutableImageEx@20>
proto_ImageNtHeader typedef proto stdcall :PVOID
externdef stdcall _imp__ImageNtHeader@4: ptr proto_ImageNtHeader
ImageNtHeader equ <_imp__ImageNtHeader@4>
proto_ImageDirectoryEntryToDataEx typedef proto stdcall :PVOID, :BOOLEAN, :WORD, :PULONG, :ptr PIMAGE_SECTION_HEADER
externdef stdcall _imp__ImageDirectoryEntryToDataEx@20: ptr proto_ImageDirectoryEntryToDataEx
ImageDirectoryEntryToDataEx equ <_imp__ImageDirectoryEntryToDataEx@20>
proto_ImageDirectoryEntryToData typedef proto stdcall :PVOID, :BOOLEAN, :WORD, :PULONG
externdef stdcall _imp__ImageDirectoryEntryToData@16: ptr proto_ImageDirectoryEntryToData
ImageDirectoryEntryToData equ <_imp__ImageDirectoryEntryToData@16>
proto_ImageRvaToSection typedef proto stdcall :PIMAGE_NT_HEADERS, :PVOID, :DWORD
externdef stdcall _imp__ImageRvaToSection@12: ptr proto_ImageRvaToSection
ImageRvaToSection equ <_imp__ImageRvaToSection@12>
proto_ImageRvaToVa typedef proto stdcall :PIMAGE_NT_HEADERS, :PVOID, :DWORD, :ptr PIMAGE_SECTION_HEADER
externdef stdcall _imp__ImageRvaToVa@16: ptr proto_ImageRvaToVa
ImageRvaToVa equ <_imp__ImageRvaToVa@16>
;// Symbol server exports
proto_PSYMBOLSERVERPROC typedef proto  :LPSTR,:LPSTR,:PVOID,:DWORD,:DWORD,:LPSTR
PSYMBOLSERVERPROC typedef ptr proto_PSYMBOLSERVERPROC
proto_PSYMBOLSERVEROPENPROC typedef proto  
PSYMBOLSERVEROPENPROC typedef ptr proto_PSYMBOLSERVEROPENPROC
proto_PSYMBOLSERVERCLOSEPROC typedef proto  
PSYMBOLSERVERCLOSEPROC typedef ptr proto_PSYMBOLSERVERCLOSEPROC
proto_PSYMBOLSERVERSETOPTIONSPROC typedef proto  :UINT_PTR,:ULONG64
PSYMBOLSERVERSETOPTIONSPROC typedef ptr proto_PSYMBOLSERVERSETOPTIONSPROC
proto_PSYMBOLSERVERCALLBACKPROC typedef proto stdcall :UINT_PTR,:ULONG64,:ULONG64
PSYMBOLSERVERCALLBACKPROC typedef ptr proto_PSYMBOLSERVERCALLBACKPROC
proto_PSYMBOLSERVERGETOPTIONSPROC typedef proto  
PSYMBOLSERVERGETOPTIONSPROC typedef ptr proto_PSYMBOLSERVERGETOPTIONSPROC
SSRVOPT_CALLBACK	EQU	01h
SSRVOPT_DWORD	EQU	02h
SSRVOPT_DWORDPTR	EQU	04h
SSRVOPT_GUIDPTR	EQU	08h
SSRVOPT_OLDGUIDPTR	EQU	10h
SSRVOPT_UNATTENDED	EQU	20h
SSRVOPT_RESET	EQU	- 1
SSRVACTION_TRACE	EQU	1

;// This api won't be ported to Win64 - Fix your code.
IMAGE_DEBUG_INFORMATION	struct 
List	LIST_ENTRY	<>
ReservedSize	DWORD	?
ReservedMappedBase	PVOID	?
ReservedMachine	WORD	?
ReservedCharacteristics	WORD	?
ReservedCheckSum	DWORD	?
ImageBase	DWORD	?
SizeOfImage	DWORD	?
ReservedNumberOfSections	DWORD	?
ReservedSections	PIMAGE_SECTION_HEADER	?
ReservedExportedNamesSize	DWORD	?
ReservedExportedNames	PSTR	?
ReservedNumberOfFunctionTableEntries	DWORD	?
ReservedFunctionTableEntries	PIMAGE_FUNCTION_ENTRY	?
ReservedLowestFunctionStartingAddress	DWORD	?
ReservedHighestFunctionEndingAddress	DWORD	?
ReservedNumberOfFpoTableEntries	DWORD	?
ReservedFpoTableEntries	PFPO_DATA	?
SizeOfCoffSymbols	DWORD	?
CoffSymbols	PIMAGE_COFF_SYMBOLS_HEADER	?
ReservedSizeOfCodeViewSymbols	DWORD	?
ReservedCodeViewSymbols	PVOID	?
ImageFilePath	PSTR	?
ImageFileName	PSTR	?
ReservedDebugFilePath	PSTR	?
ReservedTimeDateStamp	DWORD	?
ReservedRomImage	BOOL	?
ReservedDebugDirectory	PIMAGE_DEBUG_DIRECTORY	?
ReservedNumberOfDebugDirectories	DWORD	?
ReservedOriginalFunctionTableBaseAddress	DWORD	?
Reserved	DWORD 2 dup (?)
IMAGE_DEBUG_INFORMATION	ends

PIMAGE_DEBUG_INFORMATION typedef ptr IMAGE_DEBUG_INFORMATION

proto_MapDebugInformation typedef proto stdcall :HANDLE, :PSTR, :PSTR, :DWORD
externdef stdcall _imp__MapDebugInformation@16: ptr proto_MapDebugInformation
MapDebugInformation equ <_imp__MapDebugInformation@16>
proto_UnmapDebugInformation typedef proto stdcall :PIMAGE_DEBUG_INFORMATION
externdef stdcall _imp__UnmapDebugInformation@4: ptr proto_UnmapDebugInformation
UnmapDebugInformation equ <_imp__UnmapDebugInformation@4>

proto_SearchTreeForFile typedef proto stdcall :PSTR, :PSTR, :PSTR
externdef stdcall _imp__SearchTreeForFile@12: ptr proto_SearchTreeForFile
SearchTreeForFile equ <_imp__SearchTreeForFile@12>
proto_MakeSureDirectoryPathExists typedef proto stdcall :PCSTR
externdef stdcall _imp__MakeSureDirectoryPathExists@4: ptr proto_MakeSureDirectoryPathExists
MakeSureDirectoryPathExists equ <_imp__MakeSureDirectoryPathExists@4>
;//
;// UnDecorateSymbolName Flags
;//
UNDNAME_COMPLETE	EQU	0000h;// Enable full undecoration
UNDNAME_NO_LEADING_UNDERSCORES	EQU	0001h;// Remove leading underscores from MS extended keywords
UNDNAME_NO_MS_KEYWORDS	EQU	0002h;// Disable expansion of MS extended keywords
UNDNAME_NO_FUNCTION_RETURNS	EQU	0004h;// Disable expansion of return type for primary declaration
UNDNAME_NO_ALLOCATION_MODEL	EQU	0008h;// Disable expansion of the declaration model
UNDNAME_NO_ALLOCATION_LANGUAGE	EQU	0010h;// Disable expansion of the declaration language specifier
UNDNAME_NO_MS_THISTYPE	EQU	0020h;// NYI Disable expansion of MS keywords on the 'this' type for primary declaration
UNDNAME_NO_CV_THISTYPE	EQU	0040h;// NYI Disable expansion of CV modifiers on the 'this' type for primary declaration
UNDNAME_NO_THISTYPE	EQU	0060h;// Disable all modifiers on the 'this' type
UNDNAME_NO_ACCESS_SPECIFIERS	EQU	0080h;// Disable expansion of access specifiers for members
UNDNAME_NO_THROW_SIGNATURES	EQU	0100h;// Disable expansion of 'throw-signatures' for functions and pointers to functions
UNDNAME_NO_MEMBER_TYPE	EQU	0200h;// Disable expansion of 'static' or 'virtual'ness of members
UNDNAME_NO_RETURN_UDT_MODEL	EQU	0400h;// Disable expansion of MS model for UDT returns
UNDNAME_32_BIT_DECODE	EQU	0800h;// Undecorate 32-bit decorated names
UNDNAME_NAME_ONLY	EQU	1000h;// Crack only the name for primary declaration;
;//  return just [scope::]name.  Does expand template params
UNDNAME_NO_ARGUMENTS	EQU	2000h;// Don't undecorate arguments to function
UNDNAME_NO_SPECIAL_SYMS	EQU	4000h;// Don't undecorate special names (v-table, vcall, vector xxx, metatype, etc)
proto_UnDecorateSymbolName typedef proto stdcall :PCSTR, :PSTR, :DWORD, :DWORD
externdef stdcall _imp__UnDecorateSymbolName@16: ptr proto_UnDecorateSymbolName
UnDecorateSymbolName equ <_imp__UnDecorateSymbolName@16>
;// See above.
;//
;// these values are used for synthesized file types
;// that can be passed in as image headers instead of
;// the standard ones from ntimage.h
;//
DBHHEADER_DEBUGDIRS	EQU	1h
MODLOAD_DATA	struct 
ssize	DWORD	?
;// size of this struct
ssig	DWORD	?
;// signature identifying the passed data
data	PVOID	?
;// pointer to passed data
size_	DWORD	?
;// size of passed data
flags	DWORD	?
;// options
MODLOAD_DATA	ends

PMODLOAD_DATA typedef ptr MODLOAD_DATA

;//
;// StackWalking API
;//
ADDRESS_MODE typedef DWORD
AddrMode1616 = 0
AddrMode1632 = 1
AddrModeReal = 2
AddrModeFlat = 3

ADDRESS64	struct 
Offset_	DWORD64	?
Segment_	WORD	?
Mode	ADDRESS_MODE	?
ADDRESS64	ends

LPADDRESS64 typedef ptr ADDRESS64

ADDRESS	struct 4
Offset_	DWORD	?
Segment_	WORD	?
Mode	ADDRESS_MODE	?
ADDRESS	ends

LPADDRESS typedef ptr ADDRESS

Address32To64 proto  :LPADDRESS, :LPADDRESS64
Address64To32 proto  :LPADDRESS64, :LPADDRESS

;//
;// This structure is included in the STACKFRAME structure,
;// and is used to trace through usermode callbacks in a thread's
;// kernel stack.  The values must be copied by the kernel debugger
;// from the DBGKD_GET_VERSION and WAIT_STATE_CHANGE packets.
;//
;//
;// New KDHELP structure for 64 bit system support.
;// This structure is preferred in new code.
;//
KDHELP64	struct 
;//
;// address of kernel thread object, as provided in the
;// WAIT_STATE_CHANGE packet.
;//
Thread	DWORD64	?
;//
;// offset in thread object to pointer to the current callback frame
;// in kernel stack.
;//
ThCallbackStack	DWORD	?
;//
;// offset in thread object to pointer to the current callback backing
;// store frame in kernel stack.
;//
ThCallbackBStore	DWORD	?
;//
;// offsets to values in frame:
;//
;// address of next callback frame
NextCallback	DWORD	?
;// address of saved frame pointer (if applicable)
FramePointer	DWORD	?
;//
;// Address of the kernel function that calls out to user mode
;//
KiCallUserMode	DWORD64	?
;//
;// Address of the user mode dispatcher function
;//
KeUserCallbackDispatcher	DWORD64	?
;//
;// Lowest kernel mode address
;//
SystemRangeStart	DWORD64	?
Reserved	DWORD64 8 dup (?)
KDHELP64	ends

PKDHELP64 typedef ptr KDHELP64

KDHELP	struct 
;//
;// address of kernel thread object, as provided in the
;// WAIT_STATE_CHANGE packet.
;//
Thread	DWORD	?
;//
;// offset in thread object to pointer to the current callback frame
;// in kernel stack.
;//
ThCallbackStack	DWORD	?
;//
;// offsets to values in frame:
;//
;// address of next callback frame
NextCallback	DWORD	?
;// address of saved frame pointer (if applicable)
FramePointer	DWORD	?
;//
;// Address of the kernel function that calls out to user mode
;//
KiCallUserMode	DWORD	?
;//
;// Address of the user mode dispatcher function
;//
KeUserCallbackDispatcher	DWORD	?
;//
;// Lowest kernel mode address
;//
SystemRangeStart	DWORD	?
;//
;// offset in thread object to pointer to the current callback backing
;// store frame in kernel stack.
;//
ThCallbackBStore	DWORD	?
Reserved	DWORD 8 dup (?)
KDHELP	ends

PKDHELP typedef ptr KDHELP

KdHelp32To64 proto  :PKDHELP, :PKDHELP64

STACKFRAME64	struct 
AddrPC	ADDRESS64	<>
;// program counter
AddrReturn	ADDRESS64	<>
;// return address
AddrFrame	ADDRESS64	<>
;// frame pointer
AddrStack	ADDRESS64	<>
;// stack pointer
AddrBStore	ADDRESS64	<>
;// backing store pointer
FuncTableEntry	PVOID	?
;// pointer to pdata/fpo or NULL
Params	DWORD64 4 dup (?)
;// possible arguments to the function
BOOL	DWORD	?
;// WOW far call
Virtual	BOOL	?
;// is this a virtual frame?
Reserved	DWORD64 3 dup (?)
KdHelp	KDHELP64	<>
STACKFRAME64	ends

LPSTACKFRAME64 typedef ptr STACKFRAME64

STACKFRAME	struct 
AddrPC	ADDRESS	<>
;// program counter
AddrReturn	ADDRESS	<>
;// return address
AddrFrame	ADDRESS	<>
;// frame pointer
AddrStack	ADDRESS	<>
;// stack pointer
FuncTableEntry	PVOID	?
;// pointer to pdata/fpo or NULL
Params	DWORD 4 dup (?)
;// possible arguments to the function
BOOL	DWORD	?
;// WOW far call
Virtual	BOOL	?
;// is this a virtual frame?
Reserved	DWORD 3 dup (?)
KdHelp	KDHELP	<>
AddrBStore	ADDRESS	<>
;// backing store pointer
STACKFRAME	ends

LPSTACKFRAME typedef ptr STACKFRAME


proto_PREAD_PROCESS_MEMORY_ROUTINE64 typedef proto stdcall :HANDLE,:DWORD64,:PVOID,:DWORD,:LPDWORD
PREAD_PROCESS_MEMORY_ROUTINE64 typedef ptr proto_PREAD_PROCESS_MEMORY_ROUTINE64
proto_PFUNCTION_TABLE_ACCESS_ROUTINE64 typedef proto stdcall :HANDLE,:DWORD64
PFUNCTION_TABLE_ACCESS_ROUTINE64 typedef ptr proto_PFUNCTION_TABLE_ACCESS_ROUTINE64
proto_PGET_MODULE_BASE_ROUTINE64 typedef proto stdcall :HANDLE,:DWORD64
PGET_MODULE_BASE_ROUTINE64 typedef ptr proto_PGET_MODULE_BASE_ROUTINE64
proto_PTRANSLATE_ADDRESS_ROUTINE64 typedef proto stdcall :HANDLE,:HANDLE,:LPADDRESS64
PTRANSLATE_ADDRESS_ROUTINE64 typedef ptr proto_PTRANSLATE_ADDRESS_ROUTINE64
proto_StackWalk64 typedef proto stdcall :DWORD, :HANDLE, :HANDLE, :LPSTACKFRAME64, :PVOID, :PREAD_PROCESS_MEMORY_ROUTINE64, :PFUNCTION_TABLE_ACCESS_ROUTINE64, :PGET_MODULE_BASE_ROUTINE64, :PTRANSLATE_ADDRESS_ROUTINE64
externdef stdcall _imp__StackWalk64@36: ptr proto_StackWalk64
StackWalk64 equ <_imp__StackWalk64@36>


proto_PREAD_PROCESS_MEMORY_ROUTINE typedef proto stdcall :HANDLE,:DWORD,:PVOID,:DWORD,:PDWORD
PREAD_PROCESS_MEMORY_ROUTINE typedef ptr proto_PREAD_PROCESS_MEMORY_ROUTINE
proto_PFUNCTION_TABLE_ACCESS_ROUTINE typedef proto stdcall :HANDLE,:DWORD
PFUNCTION_TABLE_ACCESS_ROUTINE typedef ptr proto_PFUNCTION_TABLE_ACCESS_ROUTINE
proto_PGET_MODULE_BASE_ROUTINE typedef proto stdcall :HANDLE,:DWORD
PGET_MODULE_BASE_ROUTINE typedef ptr proto_PGET_MODULE_BASE_ROUTINE
proto_PTRANSLATE_ADDRESS_ROUTINE typedef proto stdcall :HANDLE,:HANDLE,:LPADDRESS
PTRANSLATE_ADDRESS_ROUTINE typedef ptr proto_PTRANSLATE_ADDRESS_ROUTINE
proto_StackWalk typedef proto stdcall :DWORD, :HANDLE, :HANDLE, :LPSTACKFRAME, :PVOID, :PREAD_PROCESS_MEMORY_ROUTINE, :PFUNCTION_TABLE_ACCESS_ROUTINE, :PGET_MODULE_BASE_ROUTINE, :PTRANSLATE_ADDRESS_ROUTINE
externdef stdcall _imp__StackWalk@36: ptr proto_StackWalk
StackWalk equ <_imp__StackWalk@36>

API_VERSION_NUMBER	EQU	9
API_VERSION	struct 
MajorVersion	WORD	?
MinorVersion	WORD	?
Revision	WORD	?
Reserved	WORD	?
API_VERSION	ends

LPAPI_VERSION typedef ptr API_VERSION

proto_ImagehlpApiVersion typedef proto stdcall 
externdef stdcall _imp__ImagehlpApiVersion@0: ptr proto_ImagehlpApiVersion
ImagehlpApiVersion equ <_imp__ImagehlpApiVersion@0>
proto_ImagehlpApiVersionEx typedef proto stdcall :LPAPI_VERSION
externdef stdcall _imp__ImagehlpApiVersionEx@4: ptr proto_ImagehlpApiVersionEx
ImagehlpApiVersionEx equ <_imp__ImagehlpApiVersionEx@4>
proto_GetTimestampForLoadedLibrary typedef proto stdcall :HMODULE
externdef stdcall _imp__GetTimestampForLoadedLibrary@4: ptr proto_GetTimestampForLoadedLibrary
GetTimestampForLoadedLibrary equ <_imp__GetTimestampForLoadedLibrary@4>
;//
;// typedefs for function pointers
;//
proto_PSYM_ENUMMODULES_CALLBACK64 typedef proto stdcall :PSTR,:DWORD64,:PVOID
PSYM_ENUMMODULES_CALLBACK64 typedef ptr proto_PSYM_ENUMMODULES_CALLBACK64
proto_PSYM_ENUMSYMBOLS_CALLBACK64 typedef proto stdcall :PSTR,:DWORD64,:DWORD,:PVOID
PSYM_ENUMSYMBOLS_CALLBACK64 typedef ptr proto_PSYM_ENUMSYMBOLS_CALLBACK64
proto_PSYM_ENUMSYMBOLS_CALLBACK64W typedef proto stdcall :PWSTR,:DWORD64,:DWORD,:PVOID
PSYM_ENUMSYMBOLS_CALLBACK64W typedef ptr proto_PSYM_ENUMSYMBOLS_CALLBACK64W
proto_PENUMLOADED_MODULES_CALLBACK64 typedef proto stdcall :PSTR,:DWORD64,:DWORD,:PVOID
PENUMLOADED_MODULES_CALLBACK64 typedef ptr proto_PENUMLOADED_MODULES_CALLBACK64
proto_PSYMBOL_REGISTERED_CALLBACK64 typedef proto stdcall :HANDLE,:DWORD,:ULONG64,:ULONG64
PSYMBOL_REGISTERED_CALLBACK64 typedef ptr proto_PSYMBOL_REGISTERED_CALLBACK64
proto_PSYMBOL_FUNCENTRY_CALLBACK typedef proto stdcall :HANDLE,:DWORD,:PVOID
PSYMBOL_FUNCENTRY_CALLBACK typedef ptr proto_PSYMBOL_FUNCENTRY_CALLBACK
proto_PSYMBOL_FUNCENTRY_CALLBACK64 typedef proto stdcall :HANDLE,:ULONG64,:ULONG64
PSYMBOL_FUNCENTRY_CALLBACK64 typedef ptr proto_PSYMBOL_FUNCENTRY_CALLBACK64

proto_PSYM_ENUMMODULES_CALLBACK typedef proto stdcall :PSTR,:DWORD,:PVOID
PSYM_ENUMMODULES_CALLBACK typedef ptr proto_PSYM_ENUMMODULES_CALLBACK
proto_PSYM_ENUMSYMBOLS_CALLBACK typedef proto stdcall :PSTR,:DWORD,:DWORD,:PVOID
PSYM_ENUMSYMBOLS_CALLBACK typedef ptr proto_PSYM_ENUMSYMBOLS_CALLBACK
proto_PSYM_ENUMSYMBOLS_CALLBACKW typedef proto stdcall :PWSTR,:DWORD,:DWORD,:PVOID
PSYM_ENUMSYMBOLS_CALLBACKW typedef ptr proto_PSYM_ENUMSYMBOLS_CALLBACKW
proto_PENUMLOADED_MODULES_CALLBACK typedef proto stdcall :PSTR,:DWORD,:DWORD,:PVOID
PENUMLOADED_MODULES_CALLBACK typedef ptr proto_PENUMLOADED_MODULES_CALLBACK
proto_PSYMBOL_REGISTERED_CALLBACK typedef proto stdcall :HANDLE,:DWORD,:PVOID,:PVOID
PSYMBOL_REGISTERED_CALLBACK typedef ptr proto_PSYMBOL_REGISTERED_CALLBACK

;//
;// symbol flags
;//
SYMF_OMAP_GENERATED	EQU	00000001h
SYMF_OMAP_MODIFIED	EQU	00000002h
ifndef _DBGHELP_USER_GENERATED_SYMBOLS_NOTSUPPORTED
SYMF_USER_GENERATED	EQU	00000004h
endif ;// !_DBGHELP_USER_GENERATED_SYMBOLS_NOTSUPPORTED
SYMF_REGISTER	EQU	00000008h
SYMF_REGREL	EQU	00000010h
SYMF_FRAMEREL	EQU	00000020h
SYMF_PARAMETER	EQU	00000040h
SYMF_LOCAL	EQU	00000080h
SYMF_CONSTANT	EQU	00000100h
SYMF_EXPORT	EQU	00000200h
SYMF_FORWARDER	EQU	00000400h
SYMF_FUNCTION	EQU	00000800h
;//
;// symbol type enumeration
;//
SYM_TYPE typedef DWORD
SymNone = 0 
SymCoff = 1
SymCv = 2
SymPdb = 3
SymExport = 4
SymDeferred = 5
SymSym = 6
;// .sym file
SymDia = 7
NumSymTypes = 8

;//
;// symbol data structure
;//
IMAGEHLP_SYMBOL64	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_SYMBOL64)
Address	DWORD64	?
;// virtual address including dll base address
Size_	DWORD	?
;// estimated size of symbol, can be zero
Flags	DWORD	?
;// info about the symbols, see the SYMF defines
MaxNameLength	DWORD	?
;// maximum size of symbol name in 'Name'
Name_	CHAR 1 dup (?)
;// symbol name (null terminated string)
IMAGEHLP_SYMBOL64	ends

PIMAGEHLP_SYMBOL64 typedef ptr IMAGEHLP_SYMBOL64

IMAGEHLP_SYMBOL	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_SYMBOL)
Address	DWORD	?
;// virtual address including dll base address
Size_	DWORD	?
;// estimated size of symbol, can be zero
Flags	DWORD	?
;// info about the symbols, see the SYMF defines
MaxNameLength	DWORD	?
;// maximum size of symbol name in 'Name'
Name_	CHAR 1 dup (?)
;// symbol name (null terminated string)
IMAGEHLP_SYMBOL	ends

PIMAGEHLP_SYMBOL typedef ptr IMAGEHLP_SYMBOL


;//
;// module data structure
;//
IMAGEHLP_MODULE64	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_MODULE64)
BaseOfImage	DWORD64	?
;// base load address of module
ImageSize	DWORD	?
;// virtual size of the loaded module
TimeDateStamp	DWORD	?
;// date/time stamp from pe header
CheckSum	DWORD	?
;// checksum from the pe header
NumSyms	DWORD	?
;// number of symbols in the symbol table
SymType	SYM_TYPE	?
;// type of symbols loaded
ModuleName	CHAR 32 dup (?)
;// module name
ImageName	CHAR 256 dup (?)
;// image name
LoadedImageName	CHAR 256 dup (?)
;// symbol file name
IMAGEHLP_MODULE64	ends

PIMAGEHLP_MODULE64 typedef ptr IMAGEHLP_MODULE64

IMAGEHLP_MODULEW64	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_MODULE64)
BaseOfImage	DWORD64	?
;// base load address of module
ImageSize	DWORD	?
;// virtual size of the loaded module
TimeDateStamp	DWORD	?
;// date/time stamp from pe header
CheckSum	DWORD	?
;// checksum from the pe header
NumSyms	DWORD	?
;// number of symbols in the symbol table
SymType	SYM_TYPE	?
;// type of symbols loaded
ModuleName	WCHAR 32 dup (?)
;// module name
ImageName	WCHAR 256 dup (?)
;// image name
LoadedImageName	WCHAR 256 dup (?)
;// symbol file name
IMAGEHLP_MODULEW64	ends

PIMAGEHLP_MODULEW64 typedef ptr IMAGEHLP_MODULEW64

IMAGEHLP_MODULE	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_MODULE)
BaseOfImage	DWORD	?
;// base load address of module
ImageSize	DWORD	?
;// virtual size of the loaded module
TimeDateStamp	DWORD	?
;// date/time stamp from pe header
CheckSum	DWORD	?
;// checksum from the pe header
NumSyms	DWORD	?
;// number of symbols in the symbol table
SymType	SYM_TYPE	?
;// type of symbols loaded
ModuleName	CHAR 32 dup (?)
;// module name
ImageName	CHAR 256 dup (?)
;// image name
LoadedImageName	CHAR 256 dup (?)
;// symbol file name
IMAGEHLP_MODULE	ends

PIMAGEHLP_MODULE typedef ptr IMAGEHLP_MODULE

IMAGEHLP_MODULEW	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_MODULE)
BaseOfImage	DWORD	?
;// base load address of module
ImageSize	DWORD	?
;// virtual size of the loaded module
TimeDateStamp	DWORD	?
;// date/time stamp from pe header
CheckSum	DWORD	?
;// checksum from the pe header
NumSyms	DWORD	?
;// number of symbols in the symbol table
SymType	SYM_TYPE	?
;// type of symbols loaded
ModuleName	WCHAR 32 dup (?)
;// module name
ImageName	WCHAR 256 dup (?)
;// image name
LoadedImageName	WCHAR 256 dup (?)
;// symbol file name
IMAGEHLP_MODULEW	ends

PIMAGEHLP_MODULEW typedef ptr IMAGEHLP_MODULEW


;//
;// source file line data structure
;//
IMAGEHLP_LINE64	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_LINE64)
Key	PVOID	?
;// internal
LineNumber	DWORD	?
;// line number in file
FileName	PCHAR	?
;// full filename
Address	DWORD64	?
;// first instruction of line
IMAGEHLP_LINE64	ends

PIMAGEHLP_LINE64 typedef ptr IMAGEHLP_LINE64

IMAGEHLP_LINE	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_LINE)
Key	PVOID	?
;// internal
LineNumber	DWORD	?
;// line number in file
FileName	PCHAR	?
;// full filename
Address	DWORD	?
;// first instruction of line
IMAGEHLP_LINE	ends

PIMAGEHLP_LINE typedef ptr IMAGEHLP_LINE


;//
;// source file structure
;//
SOURCEFILE	struct 
ModBase	DWORD64	?
;// base address of loaded module
FileName	PCHAR	?
;// full filename of source
SOURCEFILE	ends

PSOURCEFILE typedef ptr SOURCEFILE

;//
;// data structures used for registered symbol callbacks
;//
CBA_DEFERRED_SYMBOL_LOAD_START	EQU	00000001h
CBA_DEFERRED_SYMBOL_LOAD_COMPLETE	EQU	00000002h
CBA_DEFERRED_SYMBOL_LOAD_FAILURE	EQU	00000003h
CBA_SYMBOLS_UNLOADED	EQU	00000004h
CBA_DUPLICATE_SYMBOL	EQU	00000005h
CBA_READ_MEMORY	EQU	00000006h
CBA_DEFERRED_SYMBOL_LOAD_CANCEL	EQU	00000007h
CBA_SET_OPTIONS	EQU	00000008h
CBA_EVENT	EQU	00000010h
CBA_DEBUG_INFO	EQU	10000000h
IMAGEHLP_CBA_READ_MEMORY	struct 
addr_	DWORD64	?
;// address to read from
buf	PVOID	?
;// buffer to read to
bytes	DWORD	?
;// amount of bytes to read
bytesread	DWORD	?
;// pointer to store amount of bytes read
IMAGEHLP_CBA_READ_MEMORY	ends

PIMAGEHLP_CBA_READ_MEMORY typedef ptr IMAGEHLP_CBA_READ_MEMORY

sevInfo = 0 
sevProblem = 1
sevAttn = 2
sevFatal = 3
sevMax = 4

;// unused
IMAGEHLP_CBA_EVENT	struct 
severity	DWORD	?
;// values from sevInfo to sevFatal
code	DWORD	?
;// numerical code IDs the error
desc	PCHAR	?
;// may contain a text description of the error
object	PVOID	?
;// value dependant upon the error code
IMAGEHLP_CBA_EVENT	ends

PIMAGEHLP_CBA_EVENT typedef ptr IMAGEHLP_CBA_EVENT

IMAGEHLP_DEFERRED_SYMBOL_LOAD64	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_DEFERRED_SYMBOL_LOAD64)
BaseOfImage	DWORD64	?
;// base load address of module
CheckSum	DWORD	?
;// checksum from the pe header
TimeDateStamp	DWORD	?
;// date/time stamp from pe header
FileName	CHAR MAX_PATH dup (?)
;// symbols file or image name
Reparse	BOOLEAN	?
;// load failure reparse
IMAGEHLP_DEFERRED_SYMBOL_LOAD64	ends

PIMAGEHLP_DEFERRED_SYMBOL_LOAD64 typedef ptr IMAGEHLP_DEFERRED_SYMBOL_LOAD64

IMAGEHLP_DEFERRED_SYMBOL_LOAD	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_DEFERRED_SYMBOL_LOAD)
BaseOfImage	DWORD	?
;// base load address of module
CheckSum	DWORD	?
;// checksum from the pe header
TimeDateStamp	DWORD	?
;// date/time stamp from pe header
FileName	CHAR MAX_PATH dup (?)
;// symbols file or image name
Reparse	BOOLEAN	?
;// load failure reparse
IMAGEHLP_DEFERRED_SYMBOL_LOAD	ends

PIMAGEHLP_DEFERRED_SYMBOL_LOAD typedef ptr IMAGEHLP_DEFERRED_SYMBOL_LOAD


IMAGEHLP_DUPLICATE_SYMBOL64	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_DUPLICATE_SYMBOL64)
NumberOfDups	DWORD	?
;// number of duplicates in the Symbol array
Symbol	PIMAGEHLP_SYMBOL64	?
;// array of duplicate symbols
SelectedSymbol	DWORD	?
;// symbol selected (-1 to start)
IMAGEHLP_DUPLICATE_SYMBOL64	ends

PIMAGEHLP_DUPLICATE_SYMBOL64 typedef ptr IMAGEHLP_DUPLICATE_SYMBOL64

IMAGEHLP_DUPLICATE_SYMBOL	struct 
SizeOfStruct	DWORD	?
;// set to sizeof(IMAGEHLP_DUPLICATE_SYMBOL)
NumberOfDups	DWORD	?
;// number of duplicates in the Symbol array
Symbol	PIMAGEHLP_SYMBOL	?
;// array of duplicate symbols
SelectedSymbol	DWORD	?
;// symbol selected (-1 to start)
IMAGEHLP_DUPLICATE_SYMBOL	ends

PIMAGEHLP_DUPLICATE_SYMBOL typedef ptr IMAGEHLP_DUPLICATE_SYMBOL

;//
;// options that are set/returned by SymSetOptions() & SymGetOptions()
;// these are used as a mask
;//
SYMOPT_CASE_INSENSITIVE	EQU	00000001h
SYMOPT_UNDNAME	EQU	00000002h
SYMOPT_DEFERRED_LOADS	EQU	00000004h
SYMOPT_NO_CPP	EQU	00000008h
SYMOPT_LOAD_LINES	EQU	00000010h
SYMOPT_OMAP_FIND_NEAREST	EQU	00000020h
SYMOPT_LOAD_ANYTHING	EQU	00000040h
SYMOPT_IGNORE_CVREC	EQU	00000080h
SYMOPT_NO_UNQUALIFIED_LOADS	EQU	00000100h
SYMOPT_FAIL_CRITICAL_ERRORS	EQU	00000200h
SYMOPT_EXACT_SYMBOLS	EQU	00000400h
SYMOPT_WILD_UNDERSCORE	EQU	00000800h
SYMOPT_USE_DEFAULTS	EQU	00001000h
SYMOPT_INCLUDE_32BIT_MODULES	EQU	00002000h
SYMOPT_DEBUG	EQU	80000000h
proto_SymSetOptions typedef proto stdcall :DWORD
externdef stdcall _imp__SymSetOptions@4: ptr proto_SymSetOptions
SymSetOptions equ <_imp__SymSetOptions@4>
proto_SymGetOptions typedef proto stdcall 
externdef stdcall _imp__SymGetOptions@0: ptr proto_SymGetOptions
SymGetOptions equ <_imp__SymGetOptions@0>
proto_SymCleanup typedef proto stdcall :HANDLE
externdef stdcall _imp__SymCleanup@4: ptr proto_SymCleanup
SymCleanup equ <_imp__SymCleanup@4>
proto_SymMatchString typedef proto stdcall :LPSTR, :LPSTR, :BOOL
externdef stdcall _imp__SymMatchString@12: ptr proto_SymMatchString
SymMatchString equ <_imp__SymMatchString@12>
proto_PSYM_ENUMSOURCFILES_CALLBACK typedef proto stdcall :PSOURCEFILE,:PVOID
PSYM_ENUMSOURCFILES_CALLBACK typedef ptr proto_PSYM_ENUMSOURCFILES_CALLBACK
proto_SymEnumSourceFiles typedef proto stdcall :HANDLE, :ULONG64, :LPSTR, :PSYM_ENUMSOURCFILES_CALLBACK, :PVOID
externdef stdcall _imp__SymEnumSourceFiles@24: ptr proto_SymEnumSourceFiles
SymEnumSourceFiles equ <_imp__SymEnumSourceFiles@24>
proto_SymEnumerateModules64 typedef proto stdcall :HANDLE, :PSYM_ENUMMODULES_CALLBACK64, :PVOID
externdef stdcall _imp__SymEnumerateModules64@12: ptr proto_SymEnumerateModules64
SymEnumerateModules64 equ <_imp__SymEnumerateModules64@12>

proto_SymEnumerateModules typedef proto stdcall :HANDLE, :PSYM_ENUMMODULES_CALLBACK, :PVOID
externdef stdcall _imp__SymEnumerateModules@12: ptr proto_SymEnumerateModules
SymEnumerateModules equ <_imp__SymEnumerateModules@12>

proto_SymEnumerateSymbols64 typedef proto stdcall :HANDLE, :DWORD64, :PSYM_ENUMSYMBOLS_CALLBACK64, :PVOID
externdef stdcall _imp__SymEnumerateSymbols64@16: ptr proto_SymEnumerateSymbols64
SymEnumerateSymbols64 equ <_imp__SymEnumerateSymbols64@16>
proto_SymEnumerateSymbolsW64 typedef proto stdcall :HANDLE, :DWORD64, :PSYM_ENUMSYMBOLS_CALLBACK64W, :PVOID
externdef stdcall _imp__SymEnumerateSymbolsW64@16: ptr proto_SymEnumerateSymbolsW64
SymEnumerateSymbolsW64 equ <_imp__SymEnumerateSymbolsW64@16>

proto_SymEnumerateSymbols typedef proto stdcall :HANDLE, :DWORD, :PSYM_ENUMSYMBOLS_CALLBACK, :PVOID
externdef stdcall _imp__SymEnumerateSymbols@16: ptr proto_SymEnumerateSymbols
SymEnumerateSymbols equ <_imp__SymEnumerateSymbols@16>
proto_SymEnumerateSymbolsW typedef proto stdcall :HANDLE, :DWORD, :PSYM_ENUMSYMBOLS_CALLBACKW, :PVOID
externdef stdcall _imp__SymEnumerateSymbolsW@16: ptr proto_SymEnumerateSymbolsW
SymEnumerateSymbolsW equ <_imp__SymEnumerateSymbolsW@16>

proto_EnumerateLoadedModules64 typedef proto stdcall :HANDLE, :PENUMLOADED_MODULES_CALLBACK64, :PVOID
externdef stdcall _imp__EnumerateLoadedModules64@12: ptr proto_EnumerateLoadedModules64
EnumerateLoadedModules64 equ <_imp__EnumerateLoadedModules64@12>

proto_EnumerateLoadedModules typedef proto stdcall :HANDLE, :PENUMLOADED_MODULES_CALLBACK, :PVOID
externdef stdcall _imp__EnumerateLoadedModules@12: ptr proto_EnumerateLoadedModules
EnumerateLoadedModules equ <_imp__EnumerateLoadedModules@12>

proto_SymFunctionTableAccess64 typedef proto stdcall :HANDLE, :DWORD64
externdef stdcall _imp__SymFunctionTableAccess64@8: ptr proto_SymFunctionTableAccess64
SymFunctionTableAccess64 equ <_imp__SymFunctionTableAccess64@8>

proto_SymFunctionTableAccess typedef proto stdcall :HANDLE, :DWORD
externdef stdcall _imp__SymFunctionTableAccess@8: ptr proto_SymFunctionTableAccess
SymFunctionTableAccess equ <_imp__SymFunctionTableAccess@8>

proto_SymGetModuleInfo64 typedef proto stdcall :HANDLE, :DWORD64, :PIMAGEHLP_MODULE64
externdef stdcall _imp__SymGetModuleInfo64@12: ptr proto_SymGetModuleInfo64
SymGetModuleInfo64 equ <_imp__SymGetModuleInfo64@12>
proto_SymGetModuleInfoW64 typedef proto stdcall :HANDLE, :DWORD64, :PIMAGEHLP_MODULEW64
externdef stdcall _imp__SymGetModuleInfoW64@12: ptr proto_SymGetModuleInfoW64
SymGetModuleInfoW64 equ <_imp__SymGetModuleInfoW64@12>

proto_SymGetModuleInfo typedef proto stdcall :HANDLE, :DWORD, :PIMAGEHLP_MODULE
externdef stdcall _imp__SymGetModuleInfo@12: ptr proto_SymGetModuleInfo
SymGetModuleInfo equ <_imp__SymGetModuleInfo@12>
proto_SymGetModuleInfoW typedef proto stdcall :HANDLE, :DWORD, :PIMAGEHLP_MODULEW
externdef stdcall _imp__SymGetModuleInfoW@12: ptr proto_SymGetModuleInfoW
SymGetModuleInfoW equ <_imp__SymGetModuleInfoW@12>

proto_SymGetModuleBase64 typedef proto stdcall :HANDLE, :DWORD64
externdef stdcall _imp__SymGetModuleBase64@8: ptr proto_SymGetModuleBase64
SymGetModuleBase64 equ <_imp__SymGetModuleBase64@8>

proto_SymGetModuleBase typedef proto stdcall :HANDLE, :DWORD
externdef stdcall _imp__SymGetModuleBase@8: ptr proto_SymGetModuleBase
SymGetModuleBase equ <_imp__SymGetModuleBase@8>

proto_SymGetSymNext64 typedef proto stdcall :HANDLE, :PIMAGEHLP_SYMBOL64
externdef stdcall _imp__SymGetSymNext64@8: ptr proto_SymGetSymNext64
SymGetSymNext64 equ <_imp__SymGetSymNext64@8>

proto_SymGetSymNext typedef proto stdcall :HANDLE, :PIMAGEHLP_SYMBOL
externdef stdcall _imp__SymGetSymNext@8: ptr proto_SymGetSymNext
SymGetSymNext equ <_imp__SymGetSymNext@8>

proto_SymGetSymPrev64 typedef proto stdcall :HANDLE, :PIMAGEHLP_SYMBOL64
externdef stdcall _imp__SymGetSymPrev64@8: ptr proto_SymGetSymPrev64
SymGetSymPrev64 equ <_imp__SymGetSymPrev64@8>

proto_SymGetSymPrev typedef proto stdcall :HANDLE, :PIMAGEHLP_SYMBOL
externdef stdcall _imp__SymGetSymPrev@8: ptr proto_SymGetSymPrev
SymGetSymPrev equ <_imp__SymGetSymPrev@8>

proto_SymGetLineFromAddr64 typedef proto stdcall :HANDLE, :DWORD64, :PDWORD, :PIMAGEHLP_LINE64
externdef stdcall _imp__SymGetLineFromAddr64@16: ptr proto_SymGetLineFromAddr64
SymGetLineFromAddr64 equ <_imp__SymGetLineFromAddr64@16>

proto_SymGetLineFromAddr typedef proto stdcall :HANDLE, :DWORD, :PDWORD, :PIMAGEHLP_LINE
externdef stdcall _imp__SymGetLineFromAddr@16: ptr proto_SymGetLineFromAddr
SymGetLineFromAddr equ <_imp__SymGetLineFromAddr@16>

proto_SymGetLineFromName64 typedef proto stdcall :HANDLE, :PSTR, :PSTR, :DWORD, :PLONG, :PIMAGEHLP_LINE64
externdef stdcall _imp__SymGetLineFromName64@24: ptr proto_SymGetLineFromName64
SymGetLineFromName64 equ <_imp__SymGetLineFromName64@24>

proto_SymGetLineFromName typedef proto stdcall :HANDLE, :PSTR, :PSTR, :DWORD, :PLONG, :PIMAGEHLP_LINE
externdef stdcall _imp__SymGetLineFromName@24: ptr proto_SymGetLineFromName
SymGetLineFromName equ <_imp__SymGetLineFromName@24>

proto_SymGetLineNext64 typedef proto stdcall :HANDLE, :PIMAGEHLP_LINE64
externdef stdcall _imp__SymGetLineNext64@8: ptr proto_SymGetLineNext64
SymGetLineNext64 equ <_imp__SymGetLineNext64@8>

proto_SymGetLineNext typedef proto stdcall :HANDLE, :PIMAGEHLP_LINE
externdef stdcall _imp__SymGetLineNext@8: ptr proto_SymGetLineNext
SymGetLineNext equ <_imp__SymGetLineNext@8>

proto_SymGetLinePrev64 typedef proto stdcall :HANDLE, :PIMAGEHLP_LINE64
externdef stdcall _imp__SymGetLinePrev64@8: ptr proto_SymGetLinePrev64
SymGetLinePrev64 equ <_imp__SymGetLinePrev64@8>

proto_SymGetLinePrev typedef proto stdcall :HANDLE, :PIMAGEHLP_LINE
externdef stdcall _imp__SymGetLinePrev@8: ptr proto_SymGetLinePrev
SymGetLinePrev equ <_imp__SymGetLinePrev@8>

proto_SymMatchFileName typedef proto stdcall :PSTR, :PSTR, :ptr PSTR, :ptr PSTR
externdef stdcall _imp__SymMatchFileName@16: ptr proto_SymMatchFileName
SymMatchFileName equ <_imp__SymMatchFileName@16>
proto_SymInitialize typedef proto stdcall :HANDLE, :PSTR, :BOOL
externdef stdcall _imp__SymInitialize@12: ptr proto_SymInitialize
SymInitialize equ <_imp__SymInitialize@12>
proto_SymGetSearchPath typedef proto stdcall :HANDLE, :PSTR, :DWORD
externdef stdcall _imp__SymGetSearchPath@12: ptr proto_SymGetSearchPath
SymGetSearchPath equ <_imp__SymGetSearchPath@12>
proto_SymSetSearchPath typedef proto stdcall :HANDLE, :PSTR
externdef stdcall _imp__SymSetSearchPath@8: ptr proto_SymSetSearchPath
SymSetSearchPath equ <_imp__SymSetSearchPath@8>
proto_SymLoadModule64 typedef proto stdcall :HANDLE, :HANDLE, :PSTR, :PSTR, :DWORD64, :DWORD
externdef stdcall _imp__SymLoadModule64@24: ptr proto_SymLoadModule64
SymLoadModule64 equ <_imp__SymLoadModule64@24>
proto_SymLoadModuleEx typedef proto stdcall :HANDLE, :HANDLE, :PSTR, :PSTR, :DWORD64, :DWORD, :PMODLOAD_DATA, :DWORD
externdef stdcall _imp__SymLoadModuleEx@32: ptr proto_SymLoadModuleEx
SymLoadModuleEx equ <_imp__SymLoadModuleEx@32>

proto_SymLoadModule typedef proto stdcall :HANDLE, :HANDLE, :PSTR, :PSTR, :DWORD, :DWORD
externdef stdcall _imp__SymLoadModule@24: ptr proto_SymLoadModule
SymLoadModule equ <_imp__SymLoadModule@24>

proto_SymUnloadModule64 typedef proto stdcall :HANDLE, :DWORD64
externdef stdcall _imp__SymUnloadModule64@8: ptr proto_SymUnloadModule64
SymUnloadModule64 equ <_imp__SymUnloadModule64@8>

proto_SymUnloadModule typedef proto stdcall :HANDLE, :DWORD
externdef stdcall _imp__SymUnloadModule@8: ptr proto_SymUnloadModule
SymUnloadModule equ <_imp__SymUnloadModule@8>

proto_SymUnDName64 typedef proto stdcall :PIMAGEHLP_SYMBOL64, :PSTR, :DWORD
externdef stdcall _imp__SymUnDName64@12: ptr proto_SymUnDName64
SymUnDName64 equ <_imp__SymUnDName64@12>
;// Size of the buffer
proto_SymUnDName typedef proto stdcall :PIMAGEHLP_SYMBOL, :PSTR, :DWORD
externdef stdcall _imp__SymUnDName@12: ptr proto_SymUnDName
SymUnDName equ <_imp__SymUnDName@12>
;// Size of the buffer

proto_SymRegisterCallback64 typedef proto stdcall :HANDLE, :PSYMBOL_REGISTERED_CALLBACK64, :ULONG64
externdef stdcall _imp__SymRegisterCallback64@16: ptr proto_SymRegisterCallback64
SymRegisterCallback64 equ <_imp__SymRegisterCallback64@16>
proto_SymRegisterFunctionEntryCallback64 typedef proto stdcall :HANDLE, :PSYMBOL_FUNCENTRY_CALLBACK64, :ULONG64
externdef stdcall _imp__SymRegisterFunctionEntryCallback64@16: ptr proto_SymRegisterFunctionEntryCallback64
SymRegisterFunctionEntryCallback64 equ <_imp__SymRegisterFunctionEntryCallback64@16>

proto_SymRegisterCallback typedef proto stdcall :HANDLE, :PSYMBOL_REGISTERED_CALLBACK, :PVOID
externdef stdcall _imp__SymRegisterCallback@12: ptr proto_SymRegisterCallback
SymRegisterCallback equ <_imp__SymRegisterCallback@12>
proto_SymRegisterFunctionEntryCallback typedef proto stdcall :HANDLE, :PSYMBOL_FUNCENTRY_CALLBACK, :PVOID
externdef stdcall _imp__SymRegisterFunctionEntryCallback@12: ptr proto_SymRegisterFunctionEntryCallback
SymRegisterFunctionEntryCallback equ <_imp__SymRegisterFunctionEntryCallback@12>

IMAGEHLP_SYMBOL_SRC	struct 
sizeofstruct	DWORD	?
type_	DWORD	?
file	SBYTE MAX_PATH dup (?)
IMAGEHLP_SYMBOL_SRC	ends

PIMAGEHLP_SYMBOL_SRC typedef ptr IMAGEHLP_SYMBOL_SRC

MODULE_TYPE_INFO	struct 
;// AKA TYPTYP
dataLength	WORD	?
leaf	WORD	?
data	BYTE 1 dup (?)
MODULE_TYPE_INFO	ends

PMODULE_TYPE_INFO typedef ptr MODULE_TYPE_INFO

IMAGEHLP_SYMBOL_INFO_VALUEPRESENT	EQU	1
IMAGEHLP_SYMBOL_INFO_REGISTER	EQU	<SYMF_REGISTER>;//  0x08
IMAGEHLP_SYMBOL_INFO_REGRELATIVE	EQU	<SYMF_REGREL>;//  0x10
IMAGEHLP_SYMBOL_INFO_FRAMERELATIVE	EQU	<SYMF_FRAMEREL>;//  0x20
IMAGEHLP_SYMBOL_INFO_PARAMETER	EQU	<SYMF_PARAMETER>;//  0x40
IMAGEHLP_SYMBOL_INFO_LOCAL	EQU	<SYMF_LOCAL>;//  0x80
IMAGEHLP_SYMBOL_INFO_CONSTANT	EQU	<SYMF_CONSTANT>;// 0x100
IMAGEHLP_SYMBOL_FUNCTION	EQU	<SYMF_FUNCTION>;// 0x800
SYMBOL_INFO	struct 
SizeOfStruct	DWORD	?
TypeIndex	DWORD	?
;// Type Index of symbol
Reserved	ULONG64 2 dup (?)
Reserved2	DWORD	?
Size_	DWORD	?
ModBase	ULONG64	?
;// Base Address of module comtaining this symbol
Flags	DWORD	?
Value	ULONG64	?
;// Value of symbol, ValuePresent should be 1
Address	ULONG64	?
;// Address of symbol including base address of module
Register	DWORD	?
;// register holding value or pointer to value
Scope	DWORD	?
;// scope of the symbol
Tag	DWORD	?
;// pdb classification
NameLen	DWORD	?
;// Actual length of name
MaxNameLen	DWORD	?
Name_	CHAR 1 dup (?)
;// Name of symbol
SYMBOL_INFO	ends

PSYMBOL_INFO typedef ptr SYMBOL_INFO

IMAGEHLP_STACK_FRAME	struct 
InstructionOffset	ULONG64	?
ReturnOffset	ULONG64	?
FrameOffset	ULONG64	?
StackOffset	ULONG64	?
BackingStoreOffset	ULONG64	?
FuncTableEntry	ULONG64	?
Params	ULONG64 4 dup (?)
Reserved	ULONG64 5 dup (?)
Virtual	BOOL	?
Reserved2	DWORD	?
IMAGEHLP_STACK_FRAME	ends

PIMAGEHLP_STACK_FRAME typedef ptr IMAGEHLP_STACK_FRAME

IMAGEHLP_CONTEXT typedef 
PIMAGEHLP_CONTEXT typedef ptr 
proto_SymSetContext typedef proto stdcall :HANDLE, :PIMAGEHLP_STACK_FRAME, :PIMAGEHLP_CONTEXT
externdef stdcall _imp__SymSetContext@12: ptr proto_SymSetContext
SymSetContext equ <_imp__SymSetContext@12>
proto_SymFromAddr typedef proto stdcall :HANDLE, :DWORD64, :PDWORD64, :PSYMBOL_INFO
externdef stdcall _imp__SymFromAddr@16: ptr proto_SymFromAddr
SymFromAddr equ <_imp__SymFromAddr@16>
;// While SymFromName will provide a symbol from a name,
;// SymEnumSymbols can provide the same matching information
;// for ALL symbols with a matching name, even regular
;// expressions.  That way you can search across modules
;// and differentiate between identically named symbols.
proto_SymFromName typedef proto stdcall :HANDLE, :LPSTR, :PSYMBOL_INFO
externdef stdcall _imp__SymFromName@12: ptr proto_SymFromName
SymFromName equ <_imp__SymFromName@12>
proto_PSYM_ENUMERATESYMBOLS_CALLBACK typedef proto stdcall :PSYMBOL_INFO,:DWORD,:PVOID
PSYM_ENUMERATESYMBOLS_CALLBACK typedef ptr proto_PSYM_ENUMERATESYMBOLS_CALLBACK
proto_SymEnumSymbols typedef proto stdcall :HANDLE, :ULONG64, :PCSTR, :PSYM_ENUMERATESYMBOLS_CALLBACK, :PVOID
externdef stdcall _imp__SymEnumSymbols@24: ptr proto_SymEnumSymbols
SymEnumSymbols equ <_imp__SymEnumSymbols@24>
IMAGEHLP_SYMBOL_TYPE_INFO typedef DWORD
TI_GET_SYMTAG = 0
TI_GET_SYMNAME = 1
TI_GET_LENGTH = 2
TI_GET_TYPE = 3
TI_GET_TYPEID = 4
TI_GET_BASETYPE = 5
TI_GET_ARRAYINDEXTYPEID = 6
TI_FINDCHILDREN = 7
TI_GET_DATAKIND = 8
TI_GET_ADDRESSOFFSET = 9
TI_GET_OFFSET = 10
TI_GET_VALUE = 11
TI_GET_COUNT = 12
TI_GET_CHILDRENCOUNT = 13
TI_GET_BITPOSITION = 14
TI_GET_VIRTUALBASECLASS = 15
TI_GET_VIRTUALTABLESHAPEID = 16
TI_GET_VIRTUALBASEPOINTEROFFSET = 17
TI_GET_CLASSPARENTID = 18
TI_GET_NESTED = 19
TI_GET_SYMINDEX = 20
TI_GET_LEXICALPARENT = 21
TI_GET_ADDRESS = 22
TI_GET_THISADJUST = 23

TI_FINDCHILDREN_PARAMS	struct 
Count	DWORD	?
Start	DWORD	?
ChildId	DWORD 1 dup (?)
TI_FINDCHILDREN_PARAMS	ends

proto_SymGetTypeInfo typedef proto stdcall :HANDLE, :DWORD64, :DWORD, :IMAGEHLP_SYMBOL_TYPE_INFO, :PVOID
externdef stdcall _imp__SymGetTypeInfo@20: ptr proto_SymGetTypeInfo
SymGetTypeInfo equ <_imp__SymGetTypeInfo@20>
proto_SymEnumTypes typedef proto stdcall :HANDLE, :ULONG64, :PSYM_ENUMERATESYMBOLS_CALLBACK, :PVOID
externdef stdcall _imp__SymEnumTypes@20: ptr proto_SymEnumTypes
SymEnumTypes equ <_imp__SymEnumTypes@20>
proto_SymGetTypeFromName typedef proto stdcall :HANDLE, :ULONG64, :LPSTR, :PSYMBOL_INFO
externdef stdcall _imp__SymGetTypeFromName@20: ptr proto_SymGetTypeFromName
SymGetTypeFromName equ <_imp__SymGetTypeFromName@20>
;//
;// Full user-mode dump creation.
;//
proto_PDBGHELP_CREATE_USER_DUMP_CALLBACK typedef proto stdcall :DWORD,:ptr PVOID,:LPDWORD,:PVOID
PDBGHELP_CREATE_USER_DUMP_CALLBACK typedef ptr proto_PDBGHELP_CREATE_USER_DUMP_CALLBACK
DbgHelpCreateUserDump proto stdcall :LPSTR, :PDBGHELP_CREATE_USER_DUMP_CALLBACK, :PVOID
DbgHelpCreateUserDumpW proto stdcall :LPWSTR, :PDBGHELP_CREATE_USER_DUMP_CALLBACK, :PVOID
;// -----------------------------------------------------------------
;// The following 4 legacy APIs are fully supported, but newer
;// ones are recommended.  SymFromName and SymFromAddr provide
;// much more detailed info on the returned symbol.
proto_SymGetSymFromAddr64 typedef proto stdcall :HANDLE, :DWORD64, :PDWORD64, :PIMAGEHLP_SYMBOL64
externdef stdcall _imp__SymGetSymFromAddr64@16: ptr proto_SymGetSymFromAddr64
SymGetSymFromAddr64 equ <_imp__SymGetSymFromAddr64@16>

proto_SymGetSymFromAddr typedef proto stdcall :HANDLE, :DWORD, :PDWORD, :PIMAGEHLP_SYMBOL
externdef stdcall _imp__SymGetSymFromAddr@16: ptr proto_SymGetSymFromAddr
SymGetSymFromAddr equ <_imp__SymGetSymFromAddr@16>

;// While following two APIs will provide a symbol from a name,
;// SymEnumSymbols can provide the same matching information
;// for ALL symbols with a matching name, even regular
;// expressions.  That way you can search across modules
;// and differentiate between identically named symbols.
proto_SymGetSymFromName64 typedef proto stdcall :HANDLE, :PSTR, :PIMAGEHLP_SYMBOL64
externdef stdcall _imp__SymGetSymFromName64@12: ptr proto_SymGetSymFromName64
SymGetSymFromName64 equ <_imp__SymGetSymFromName64@12>

proto_SymGetSymFromName typedef proto stdcall :HANDLE, :PSTR, :PIMAGEHLP_SYMBOL
externdef stdcall _imp__SymGetSymFromName@12: ptr proto_SymGetSymFromName
SymGetSymFromName equ <_imp__SymGetSymFromName@12>

;// -----------------------------------------------------------------
;// The following APIs exist only for backwards compatibility
;// with a pre-release version documented in an MSDN release.
;// You should use SymFindFileInPath if you want to maintain
;// future compatibility.
proto_FindFileInPath typedef proto stdcall :HANDLE, :LPSTR, :LPSTR, :PVOID, :DWORD, :DWORD, :DWORD, :LPSTR
externdef stdcall _imp__FindFileInPath@32: ptr proto_FindFileInPath
FindFileInPath equ <_imp__FindFileInPath@32>
;// You should use SymFindFileInPath if you want to maintain
;// future compatibility.
proto_FindFileInSearchPath typedef proto stdcall :HANDLE, :LPSTR, :LPSTR, :DWORD, :DWORD, :DWORD, :LPSTR
externdef stdcall _imp__FindFileInSearchPath@28: ptr proto_FindFileInSearchPath
FindFileInSearchPath equ <_imp__FindFileInSearchPath@28>
proto_SymEnumSym typedef proto stdcall :HANDLE, :ULONG64, :PSYM_ENUMERATESYMBOLS_CALLBACK, :PVOID
externdef stdcall _imp__SymEnumSym@20: ptr proto_SymEnumSym
SymEnumSym equ <_imp__SymEnumSym@20>

	;include pshpack4.inc

MINIDUMP_SIGNATURE	EQU	<( 'PMDM' )>
MINIDUMP_VERSION	EQU	42899
RVA typedef DWORD
RVA64 typedef ULONG64
MINIDUMP_LOCATION_DESCRIPTOR	struct 
DataSize	ULONG32	?
Rva	RVA	?
MINIDUMP_LOCATION_DESCRIPTOR	ends

MINIDUMP_LOCATION_DESCRIPTOR64	struct 
DataSize	ULONG64	?
Rva	RVA64	?
MINIDUMP_LOCATION_DESCRIPTOR64	ends

MINIDUMP_MEMORY_DESCRIPTOR	struct 
StartOfMemoryRange	ULONG64	?
Memory	MINIDUMP_LOCATION_DESCRIPTOR	<>
MINIDUMP_MEMORY_DESCRIPTOR	ends

PMINIDUMP_MEMORY_DESCRIPTOR typedef ptr MINIDUMP_MEMORY_DESCRIPTOR

;// DESCRIPTOR64 is used for full-memory minidumps where
;// all of the raw memory is laid out sequentially at the
;// end of the dump.  There is no need for individual RVAs
;// as the RVA is the base RVA plus the sum of the preceeding
;// data blocks.
MINIDUMP_MEMORY_DESCRIPTOR64	struct 
StartOfMemoryRange	ULONG64	?
DataSize	ULONG64	?
MINIDUMP_MEMORY_DESCRIPTOR64	ends

PMINIDUMP_MEMORY_DESCRIPTOR64 typedef ptr MINIDUMP_MEMORY_DESCRIPTOR64

MINIDUMP_HEADER	struct 
Signature	ULONG32	?
Version	ULONG32	?
NumberOfStreams	ULONG32	?
StreamDirectoryRva	RVA	?
CheckSum	ULONG32	?
union
Reserved	ULONG32	?
TimeDateStamp	ULONG32	?
ends
Flags	ULONG64	?
MINIDUMP_HEADER	ends

PMINIDUMP_HEADER typedef ptr MINIDUMP_HEADER

;//
;// The MINIDUMP_HEADER field StreamDirectoryRva points to 
;// an array of MINIDUMP_DIRECTORY structures.
;//
MINIDUMP_DIRECTORY	struct 
StreamType	ULONG32	?
Location	MINIDUMP_LOCATION_DESCRIPTOR	<>
MINIDUMP_DIRECTORY	ends

PMINIDUMP_DIRECTORY typedef ptr MINIDUMP_DIRECTORY

MINIDUMP_STRING	struct 
Length_	ULONG32	?
;// Length in bytes of the string
Buffer	WCHAR 0 dup (?)
;// Variable size buffer
MINIDUMP_STRING	ends

PMINIDUMP_STRING typedef ptr MINIDUMP_STRING

;//
;// The MINIDUMP_DIRECTORY field StreamType may be one of the following types.
;// Types will be added in the future, so if a program reading the minidump
;// header encounters a stream type it does not understand it should ignore
;// the data altogether. Any tag above LastReservedStream will not be used by
;// the system and is reserved for program-specific information.
;//
MINIDUMP_STREAM_TYPE typedef DWORD
UnusedStream = 0 
ReservedStream0 = 1 
ReservedStream1 = 2 
ThreadListStream = 3 
ModuleListStream = 4 
MemoryListStream = 5 
ExceptionStream = 6 
SystemInfoStream = 7 
ThreadExListStream = 8 
Memory64ListStream = 9 
CommentStreamA = 10 
CommentStreamW = 11 
HandleDataStream = 12 
FunctionTableStream = 13 
UnloadedModuleListStream = 14 
MiscInfoStream = 15 
LastReservedStream = 0ffffh 

;//
;// The minidump system information contains processor and
;// Operating System specific information.
;// 
;//
;// CPU information is obtained from one of two places.
;//
;//  1) On x86 computers, CPU_INFORMATION is obtained from the CPUID
;//     instruction. You must use the X86 portion of the union for X86
;//     computers.
;//
;//  2) On non-x86 architectures, CPU_INFORMATION is obtained by calling
;//     IsProcessorFeatureSupported().
;//
CPU_INFORMATION	union 
;//
;// X86 platforms use CPUID function to obtain processor information.
;//
struct X86CpuInfo
;//
;// CPUID Subfunction 0, register EAX (VendorId [0]),
;// EBX (VendorId [1]) and ECX (VendorId [2]).
;//
VendorId	ULONG32 3 dup (?)
;//
;// CPUID Subfunction 1, register EAX
;//
VersionInformation	ULONG32	?
;//
;// CPUID Subfunction 1, register EDX
;//
FeatureInformation	ULONG32	?
;//
;// CPUID, Subfunction 80000001, register EBX. This will only
;// be obtained if the vendor id is "AuthenticAMD".
;//
AMDExtendedCpuFeatures	ULONG32	?
ends
;//
;// Non-x86 platforms use processor feature flags.
;//
struct OtherCpuInfo
ProcessorFeatures	ULONG64 2 dup (?)
ends
CPU_INFORMATION	ends

PCPU_INFORMATION typedef ptr CPU_INFORMATION

MINIDUMP_SYSTEM_INFO	struct 
;//
;// ProcessorArchitecture, ProcessorLevel and ProcessorRevision are all
;// taken from the SYSTEM_INFO structure obtained by GetSystemInfo( ).
;//
ProcessorArchitecture	WORD	?
ProcessorLevel	WORD	?
ProcessorRevision	WORD	?
union
Reserved0	WORD	?
struct
NumberOfProcessors	BYTE	?
ProductType	BYTE	?
ends
ends
;//
;// MajorVersion, MinorVersion, BuildNumber, PlatformId and
;// CSDVersion are all taken from the OSVERSIONINFO structure
;// returned by GetVersionEx( ).
;//
MajorVersion	ULONG32	?
MinorVersion	ULONG32	?
BuildNumber	ULONG32	?
PlatformId	ULONG32	?
;//
;// RVA to a CSDVersion string in the string table.
;//
CSDVersionRva	RVA	?
union
Reserved1	ULONG32	?
struct
SuiteMask	WORD	?
Reserved2	WORD	?
ends
ends
Cpu	CPU_INFORMATION	<>
MINIDUMP_SYSTEM_INFO	ends

PMINIDUMP_SYSTEM_INFO typedef ptr MINIDUMP_SYSTEM_INFO

;//
;// The minidump thread contains standard thread
;// information plus an RVA to the memory for this 
;// thread and an RVA to the CONTEXT structure for
;// this thread.
;//
;//
;// ThreadId must be 4 bytes on all architectures.
;//
MINIDUMP_THREAD	struct 
ThreadId	ULONG32	?
SuspendCount	ULONG32	?
PriorityClass	ULONG32	?
Priority	ULONG32	?
Teb	ULONG64	?
Stack	MINIDUMP_MEMORY_DESCRIPTOR	<>
ThreadContext	MINIDUMP_LOCATION_DESCRIPTOR	<>
MINIDUMP_THREAD	ends

PMINIDUMP_THREAD typedef ptr MINIDUMP_THREAD

;//
;// The thread list is a container of threads.
;//
MINIDUMP_THREAD_LIST	struct 
NumberOfThreads	ULONG32	?
Threads	MINIDUMP_THREAD 0 dup (<>)
MINIDUMP_THREAD_LIST	ends

PMINIDUMP_THREAD_LIST typedef ptr MINIDUMP_THREAD_LIST

MINIDUMP_THREAD_EX	struct 
ThreadId	ULONG32	?
SuspendCount	ULONG32	?
PriorityClass	ULONG32	?
Priority	ULONG32	?
Teb	ULONG64	?
Stack	MINIDUMP_MEMORY_DESCRIPTOR	<>
ThreadContext	MINIDUMP_LOCATION_DESCRIPTOR	<>
BackingStore	MINIDUMP_MEMORY_DESCRIPTOR	<>
MINIDUMP_THREAD_EX	ends

PMINIDUMP_THREAD_EX typedef ptr MINIDUMP_THREAD_EX

;//
;// The thread list is a container of threads.
;//
MINIDUMP_THREAD_EX_LIST	struct 
NumberOfThreads	ULONG32	?
Threads	MINIDUMP_THREAD_EX 0 dup (<>)
MINIDUMP_THREAD_EX_LIST	ends

PMINIDUMP_THREAD_EX_LIST typedef ptr MINIDUMP_THREAD_EX_LIST

;//
;// The MINIDUMP_EXCEPTION is the same as EXCEPTION on Win64.
;//
MINIDUMP_EXCEPTION	struct 
ExceptionCode	ULONG32	?
ExceptionFlags	ULONG32	?
ExceptionRecord	ULONG64	?
ExceptionAddress	ULONG64	?
NumberParameters	ULONG32	?
__unusedAlignment	ULONG32	?
ExceptionInformation	ULONG64 EXCEPTION_MAXIMUM_PARAMETERS dup (?)
MINIDUMP_EXCEPTION	ends

PMINIDUMP_EXCEPTION typedef ptr MINIDUMP_EXCEPTION

;//
;// The exception information stream contains the id of the thread that caused
;// the exception (ThreadId), the exception record for the exception
;// (ExceptionRecord) and an RVA to the thread context where the exception
;// occured.
;//
MINIDUMP_EXCEPTION_STREAM	struct 
ThreadId	ULONG32	?
__alignment	ULONG32	?
ExceptionRecord	MINIDUMP_EXCEPTION	<>
ThreadContext	MINIDUMP_LOCATION_DESCRIPTOR	<>
MINIDUMP_EXCEPTION_STREAM	ends

PMINIDUMP_EXCEPTION_STREAM typedef ptr MINIDUMP_EXCEPTION_STREAM

;//
;// The MINIDUMP_MODULE contains information about a
;// a specific module. It includes the CheckSum and
;// the TimeDateStamp for the module so the module
;// can be reloaded during the analysis phase.
;//
MINIDUMP_MODULE	struct 
BaseOfImage	ULONG64	?
SizeOfImage	ULONG32	?
CheckSum	ULONG32	?
TimeDateStamp	ULONG32	?
ModuleNameRva	RVA	?
VersionInfo	VS_FIXEDFILEINFO	<>
CvRecord	MINIDUMP_LOCATION_DESCRIPTOR	<>
MiscRecord	MINIDUMP_LOCATION_DESCRIPTOR	<>
Reserved0	ULONG64	?
;// Reserved for future use.
Reserved1	ULONG64	?
;// Reserved for future use.
MINIDUMP_MODULE	ends

PMINIDUMP_MODULE typedef ptr MINIDUMP_MODULE

;//
;// The minidump module list is a container for modules.
;//
MINIDUMP_MODULE_LIST	struct 
NumberOfModules	ULONG32	?
Modules	MINIDUMP_MODULE 0 dup (<>)
MINIDUMP_MODULE_LIST	ends

PMINIDUMP_MODULE_LIST typedef ptr MINIDUMP_MODULE_LIST

;//
;// Memory Ranges
;//
MINIDUMP_MEMORY_LIST	struct 
NumberOfMemoryRanges	ULONG32	?
MemoryRanges	MINIDUMP_MEMORY_DESCRIPTOR 0 dup (<>)
MINIDUMP_MEMORY_LIST	ends

PMINIDUMP_MEMORY_LIST typedef ptr MINIDUMP_MEMORY_LIST

MINIDUMP_MEMORY64_LIST	struct 
NumberOfMemoryRanges	ULONG64	?
BaseRva	RVA64	?
MemoryRanges	MINIDUMP_MEMORY_DESCRIPTOR64 0 dup (<>)
MINIDUMP_MEMORY64_LIST	ends

PMINIDUMP_MEMORY64_LIST typedef ptr MINIDUMP_MEMORY64_LIST

;//
;// Support for user supplied exception information.
;//
MINIDUMP_EXCEPTION_INFORMATION	struct 
ThreadId	DWORD	?
ExceptionPointers	PEXCEPTION_POINTERS	?
ClientPointers	BOOL	?
MINIDUMP_EXCEPTION_INFORMATION	ends

PMINIDUMP_EXCEPTION_INFORMATION typedef ptr MINIDUMP_EXCEPTION_INFORMATION

MINIDUMP_EXCEPTION_INFORMATION64	struct 
ThreadId	DWORD	?
ExceptionRecord	ULONG64	?
ContextRecord	ULONG64	?
ClientPointers	BOOL	?
MINIDUMP_EXCEPTION_INFORMATION64	ends

PMINIDUMP_EXCEPTION_INFORMATION64 typedef ptr MINIDUMP_EXCEPTION_INFORMATION64

;//
;// Support for capturing system handle state at the time of the dump.
;//
MINIDUMP_HANDLE_DESCRIPTOR	struct 
Handle	ULONG64	?
TypeNameRva	RVA	?
ObjectNameRva	RVA	?
Attributes	ULONG32	?
GrantedAccess	ULONG32	?
HandleCount	ULONG32	?
PointerCount	ULONG32	?
MINIDUMP_HANDLE_DESCRIPTOR	ends

PMINIDUMP_HANDLE_DESCRIPTOR typedef ptr MINIDUMP_HANDLE_DESCRIPTOR

MINIDUMP_HANDLE_DATA_STREAM	struct 
SizeOfHeader	ULONG32	?
SizeOfDescriptor	ULONG32	?
NumberOfDescriptors	ULONG32	?
Reserved	ULONG32	?
MINIDUMP_HANDLE_DATA_STREAM	ends

PMINIDUMP_HANDLE_DATA_STREAM typedef ptr MINIDUMP_HANDLE_DATA_STREAM

;//
;// Support for capturing dynamic function table state at the time of the dump.
;//
MINIDUMP_FUNCTION_TABLE_DESCRIPTOR	struct 
MinimumAddress	ULONG64	?
MaximumAddress	ULONG64	?
BaseAddress	ULONG64	?
EntryCount	ULONG32	?
SizeOfAlignPad	ULONG32	?
MINIDUMP_FUNCTION_TABLE_DESCRIPTOR	ends

PMINIDUMP_FUNCTION_TABLE_DESCRIPTOR typedef ptr MINIDUMP_FUNCTION_TABLE_DESCRIPTOR

MINIDUMP_FUNCTION_TABLE_STREAM	struct 
SizeOfHeader	ULONG32	?
SizeOfDescriptor	ULONG32	?
SizeOfNativeDescriptor	ULONG32	?
SizeOfFunctionEntry	ULONG32	?
NumberOfDescriptors	ULONG32	?
SizeOfAlignPad	ULONG32	?
MINIDUMP_FUNCTION_TABLE_STREAM	ends

PMINIDUMP_FUNCTION_TABLE_STREAM typedef ptr MINIDUMP_FUNCTION_TABLE_STREAM

;//
;// The MINIDUMP_UNLOADED_MODULE contains information about a
;// a specific module that was previously loaded but no
;// longer is.  This can help with diagnosing problems where
;// callers attempt to call code that is no longer loaded.
;//
MINIDUMP_UNLOADED_MODULE	struct 
BaseOfImage	ULONG64	?
SizeOfImage	ULONG32	?
CheckSum	ULONG32	?
TimeDateStamp	ULONG32	?
ModuleNameRva	RVA	?
MINIDUMP_UNLOADED_MODULE	ends

PMINIDUMP_UNLOADED_MODULE typedef ptr MINIDUMP_UNLOADED_MODULE

;//
;// The minidump unloaded module list is a container for unloaded modules.
;//
MINIDUMP_UNLOADED_MODULE_LIST	struct 
SizeOfHeader	ULONG32	?
SizeOfEntry	ULONG32	?
NumberOfEntries	ULONG32	?
MINIDUMP_UNLOADED_MODULE_LIST	ends

PMINIDUMP_UNLOADED_MODULE_LIST typedef ptr MINIDUMP_UNLOADED_MODULE_LIST

;//
;// The miscellaneous information stream contains a variety
;// of small pieces of information.  A member is valid if
;// it's within the available size and its corresponding
;// bit is set.
;//
MINIDUMP_MISC1_PROCESS_ID	EQU	00000001h
MINIDUMP_MISC1_PROCESS_TIMES	EQU	00000002h
MINIDUMP_MISC_INFO	struct 
SizeOfInfo	ULONG32	?
Flags1	ULONG32	?
ProcessId	ULONG32	?
ProcessCreateTime	ULONG32	?
ProcessUserTime	ULONG32	?
ProcessKernelTime	ULONG32	?
MINIDUMP_MISC_INFO	ends

PMINIDUMP_MISC_INFO typedef ptr MINIDUMP_MISC_INFO

;//
;// Support for arbitrary user-defined information.
;//
MINIDUMP_USER_RECORD	struct 
Type_	ULONG32	?
Memory	MINIDUMP_LOCATION_DESCRIPTOR	<>
MINIDUMP_USER_RECORD	ends

PMINIDUMP_USER_RECORD typedef ptr MINIDUMP_USER_RECORD

MINIDUMP_USER_STREAM	struct 
Type_	ULONG32	?
BufferSize	DWORD	?
Buffer	PVOID	?
MINIDUMP_USER_STREAM	ends

PMINIDUMP_USER_STREAM typedef ptr MINIDUMP_USER_STREAM

MINIDUMP_USER_STREAM_INFORMATION	struct 
UserStreamCount	DWORD	?
UserStreamArray	PMINIDUMP_USER_STREAM	?
MINIDUMP_USER_STREAM_INFORMATION	ends

PMINIDUMP_USER_STREAM_INFORMATION typedef ptr MINIDUMP_USER_STREAM_INFORMATION

;//
;// Callback support.
;//
MINIDUMP_CALLBACK_TYPE typedef DWORD
ModuleCallback = 0
ThreadCallback = 1
ThreadExCallback = 2
IncludeThreadCallback = 3
IncludeModuleCallback = 4
MemoryCallback = 5

MINIDUMP_THREAD_CALLBACK	struct 
ThreadId	DWORD	?
ThreadHandle	HANDLE	?
Context	CONTEXT	<>
SizeOfContext	DWORD	?
StackBase	ULONG64	?
StackEnd	ULONG64	?
MINIDUMP_THREAD_CALLBACK	ends

PMINIDUMP_THREAD_CALLBACK typedef ptr MINIDUMP_THREAD_CALLBACK

MINIDUMP_THREAD_EX_CALLBACK	struct 
ThreadId	DWORD	?
ThreadHandle	HANDLE	?
Context	CONTEXT	<>
SizeOfContext	DWORD	?
StackBase	ULONG64	?
StackEnd	ULONG64	?
BackingStoreBase	ULONG64	?
BackingStoreEnd	ULONG64	?
MINIDUMP_THREAD_EX_CALLBACK	ends

PMINIDUMP_THREAD_EX_CALLBACK typedef ptr MINIDUMP_THREAD_EX_CALLBACK

MINIDUMP_INCLUDE_THREAD_CALLBACK	struct 
ThreadId	DWORD	?
MINIDUMP_INCLUDE_THREAD_CALLBACK	ends

PMINIDUMP_INCLUDE_THREAD_CALLBACK typedef ptr MINIDUMP_INCLUDE_THREAD_CALLBACK

THREAD_WRITE_FLAGS typedef DWORD
ThreadWriteThread = 0001h 
ThreadWriteStack = 0002h 
ThreadWriteContext = 0004h 
ThreadWriteBackingStore = 0008h 
ThreadWriteInstructionWindow = 0010h 
ThreadWriteThreadData = 0020h 

MINIDUMP_MODULE_CALLBACK	struct 
FullPath	PWCHAR	?
BaseOfImage	ULONG64	?
SizeOfImage	DWORD	?
CheckSum	DWORD	?
TimeDateStamp	DWORD	?
VersionInfo	VS_FIXEDFILEINFO	<>
CvRecord	PVOID	?
SizeOfCvRecord	DWORD	?
MiscRecord	PVOID	?
SizeOfMiscRecord	DWORD	?
MINIDUMP_MODULE_CALLBACK	ends

PMINIDUMP_MODULE_CALLBACK typedef ptr MINIDUMP_MODULE_CALLBACK

MINIDUMP_INCLUDE_MODULE_CALLBACK	struct 
BaseOfImage	ULONG64	?
MINIDUMP_INCLUDE_MODULE_CALLBACK	ends

PMINIDUMP_INCLUDE_MODULE_CALLBACK typedef ptr MINIDUMP_INCLUDE_MODULE_CALLBACK

MODULE_WRITE_FLAGS typedef DWORD
ModuleWriteModule = 0001h 
ModuleWriteDataSeg = 0002h 
ModuleWriteMiscRecord = 0004h 
ModuleWriteCvRecord = 0008h 
ModuleReferencedByMemory = 0010h 

MINIDUMP_CALLBACK_INPUT	struct 
ProcessId	DWORD	?
ProcessHandle	HANDLE	?
CallbackType	DWORD	?
union
Thread	MINIDUMP_THREAD_CALLBACK	<>
ThreadEx	MINIDUMP_THREAD_EX_CALLBACK	<>
Module	MINIDUMP_MODULE_CALLBACK	<>
IncludeThread	MINIDUMP_INCLUDE_THREAD_CALLBACK	<>
IncludeModule	MINIDUMP_INCLUDE_MODULE_CALLBACK	<>
ends
MINIDUMP_CALLBACK_INPUT	ends

PMINIDUMP_CALLBACK_INPUT typedef ptr MINIDUMP_CALLBACK_INPUT

MINIDUMP_CALLBACK_OUTPUT	struct 
union
ModuleWriteFlags	DWORD	?
ThreadWriteFlags	DWORD	?
struct
MemoryBase	ULONG64	?
MemorySize	DWORD	?
ends
ends
MINIDUMP_CALLBACK_OUTPUT	ends

PMINIDUMP_CALLBACK_OUTPUT typedef ptr MINIDUMP_CALLBACK_OUTPUT

;//
;// A normal minidump contains just the information
;// necessary to capture stack traces for all of the
;// existing threads in a process.
;//
;// A minidump with data segments includes all of the data
;// sections from loaded modules in order to capture
;// global variable contents.  This can make the dump much
;// larger if many modules have global data.
;//
;// A minidump with full memory includes all of the accessible
;// memory in the process and can be very large.  A minidump
;// with full memory always has the raw memory data at the end
;// of the dump so that the initial structures in the dump can
;// be mapped directly without having to include the raw
;// memory information.
;//
;// Stack and backing store memory can be filtered to remove
;// data unnecessary for stack walking.  This can improve
;// compression of stacks and also deletes data that may
;// be private and should not be stored in a dump.
;// Memory can also be scanned to see what modules are
;// referenced by stack and backing store memory to allow
;// omission of other modules to reduce dump size.
;// In either of these modes the ModuleReferencedByMemory flag
;// is set for all modules referenced before the base
;// module callbacks occur.
;//
;// On some operating systems a list of modules that were
;// recently unloaded is kept in addition to the currently
;// loaded module list.  This information can be saved in
;// the dump if desired.
;//
;// Stack and backing store memory can be scanned for referenced
;// pages in order to pick up data referenced by locals or other
;// stack memory.  This can increase the size of a dump significantly.
;//
;// Module paths may contain undesired information such as user names
;// or other important directory names so they can be stripped.  This
;// option reduces the ability to locate the proper image later
;// and should only be used in certain situations.
;//
;// Complete operating system per-process and per-thread information can
;// be gathered and stored in the dump.
;//
;// The virtual address space can be scanned for various types
;// of memory to be included in the dump.
;//
;// Code which is concerned with potentially private information
;// getting into the minidump can set a flag that automatically
;// modifies all existing and future flags to avoid placing
;// unnecessary data in the dump.  Basic data, such as stack
;// information, will still be included but optional data, such
;// as indirect memory, will not.
;//
MINIDUMP_TYPE typedef DWORD
MiniDumpNormal = 0000h 
MiniDumpWithDataSegs = 0001h 
MiniDumpWithFullMemory = 0002h 
MiniDumpWithHandleData = 0004h 
MiniDumpFilterMemory = 0008h 
MiniDumpScanMemory = 0010h 
MiniDumpWithUnloadedModules = 0020h 
MiniDumpWithIndirectlyReferencedMemory = 0040h 
MiniDumpFilterModulePaths = 0080h 
MiniDumpWithProcessThreadData = 0100h 
MiniDumpWithPrivateReadWriteMemory = 0200h 
MiniDumpWithoutOptionalData = 0400h 

;//
;// The minidump callback should modify the FieldsToWrite parameter to reflect
;// what portions of the specified thread or module should be written to the
;// file.
;//
proto_MINIDUMP_CALLBACK_ROUTINE typedef proto stdcall :PVOID,:PMINIDUMP_CALLBACK_INPUT,:PMINIDUMP_CALLBACK_OUTPUT
MINIDUMP_CALLBACK_ROUTINE typedef ptr proto_MINIDUMP_CALLBACK_ROUTINE
MINIDUMP_CALLBACK_INFORMATION	struct 
CallbackRoutine	MINIDUMP_CALLBACK_ROUTINE	?
CallbackParam	PVOID	?
MINIDUMP_CALLBACK_INFORMATION	ends

PMINIDUMP_CALLBACK_INFORMATION typedef ptr MINIDUMP_CALLBACK_INFORMATION

;//++
;//
;// PVOID
;// RVA_TO_ADDR(
;//     PVOID Mapping,
;//     ULONG Rva
;//     )
;//
;// Routine Description:
;//
;//     Map an RVA that is contained within a mapped file to it's associated
;//     flat address.
;//
;// Arguments:
;//
;//     Mapping - Base address of mapped file containing the RVA.
;//
;//     Rva - An Rva to fixup.
;//
;// Return Values:
;//
;//     A pointer to the desired data.
;//
;//--
RVA_TO_ADDR macro Mapping,Rva
	exitm <( ( ( ( Mapping ) ) + ( Rva ) ) ) >
	endm
MiniDumpWriteDump proto stdcall :HANDLE, :DWORD, :HANDLE, :MINIDUMP_TYPE, :PMINIDUMP_EXCEPTION_INFORMATION, :PMINIDUMP_USER_STREAM_INFORMATION, :PMINIDUMP_CALLBACK_INFORMATION
MiniDumpReadDumpStream proto stdcall :PVOID, :DWORD, :ptr PMINIDUMP_DIRECTORY, :ptr PVOID, :ptr DWORD


;--- errors: 0
;--- end of file ---
